"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

Object subclass:#MessageDescription
	instanceVariableNames:'parserClass name arguments argumentTypes returnType selector'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Lookup'
!

!MessageDescription class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!MessageDescription class methodsFor:'instance creation'!

new
    ^ self basicNew initialize

    "Created: / 29-08-2011 / 23:40:55 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!MessageDescription methodsFor:'accessing'!

argSize
    ^ argumentTypes size

    "Created: / 29-08-2011 / 22:02:54 / Jan Kurs <kursjan@fit.cvut.cz>"
!

argTypes
    ^ argumentTypes

    "Created: / 05-09-2011 / 21:48:45 / Jan Kurs <kursjan@fit.cvut.cz>"
!

args
    ^ arguments

    "Created: / 30-08-2011 / 21:09:04 / Jan Kurs <kursjan@fit.cvut.cz>"
!

name
    ^ name
!

parserClass
    ^ parserClass
!

parserClass:something
    parserClass := something.
!

returnType
    ^ returnType
!

runtimeArguments: args
    arguments := args

    "Created: / 29-08-2011 / 21:46:42 / Jan Kurs <kursjan@fit.cvut.cz>"
!

selector
    ^ selector
!

selector: newSelector
    selector := newSelector.
    self parse: newSelector.

    "Created: / 29-08-2011 / 21:24:25 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!MessageDescription methodsFor:'handling'!

addArgumentOfType: type
    argumentTypes add: type.

    "Created: / 29-08-2011 / 22:01:51 / Jan Kurs <kursjan@fit.cvut.cz>"
!

name: newName
    name := newName

    "Created: / 29-08-2011 / 23:39:29 / Jan Kurs <kursjan@fit.cvut.cz>"
!

returnType:something
    returnType := something.
! !

!MessageDescription methodsFor:'initialization'!

initialize
    argumentTypes := OrderedCollection new.

    "Created: / 29-08-2011 / 22:02:22 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!MessageDescription methodsFor:'parsing'!

parse:arg
    parserClass new parse: arg handler: self.

    "Created: / 29-08-2011 / 21:24:46 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!MessageDescription class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
